unit ColumnEdit;

interface

uses
     SysVars,SysConsts,SysRecords,
     TBX,
     Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, CheckLst, ComCtrls, Menus,
     ExtCtrls,MyFuncs;

type
  TForm_ColEdit = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    ListBox_Grid: TListBox;
    GroupBox2: TGroupBox;
    ListBox_All: TListBox;
    Button_Select: TButton;
    Button_Remove: TButton;
    Button_MoveUp: TButton;
    Button_MoveDown: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure Button_SelectClick(Sender: TObject);
    procedure Button_RemoveClick(Sender: TObject);
    procedure Button_MoveUpClick(Sender: TObject);
    procedure Button_MoveDownClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_ColEdit: TForm_ColEdit;

implementation

{$R *.dfm}
uses Main;

procedure TForm_ColEdit.FormShow(Sender: TObject);
var
     I    : Integer;
begin
     //
     ListBox_All.Items.Clear;
     for I:=0 to High(grFields_Member) do begin
          ListBox_All.Items.Add(grFields_Member[I].Caption);
     end;
     for I:=0 to High(grGrid_Member)  do begin
          ListBox_All.Items.Delete(ListBox_All.Items.IndexOf(grFields_Member[grGrid_Member[I]].Caption));
     end;
     if ListBox_All.Items.Count>0 then begin
          ListBox_All.ItemIndex    := 0;
     end;

     //ʾʾ
     ListBox_Grid.Items.Clear;
     for I:=0 to High(grGrid_Member) do begin
          ListBox_Grid.Items.Add(grFields_Member[grGrid_Member[I]].Caption);
     end;
     if ListBox_Grid.Items.Count>0 then begin
          ListBox_Grid.ItemIndex   := 0;
     end;
end;

procedure TForm_ColEdit.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_ColEdit.Button_OKClick(Sender: TObject);
var
     I,J       : Integer;
     S         : String;
     oSortMenu : TTBXItem;
     oSortM    : TMenuItem;
begin
     //浽Grid_Member
     SetLength(grGrid_Member,0);
     for I:=0 to ListBox_Grid.Items.Count-1 do begin
          for J:=0 to High(grFields_Member) do begin
               if grFields_Member[J].Caption = ListBox_Grid.Items[I] then begin
                    SetLength(grGrid_Member,Length(grGrid_Member)+1);
                    grGrid_Member[High(grGrid_Member)]     := J;
                    break;
               end;
          end;
     end;
     //浽ݿ
     S    := '';
     for I:=0 to High(grGrid_Member) do begin
          S    := S+IntToStr(grGrid_Member[I])+',';
     end;
     MainForm.SetSystemByID(S,siGridFields);

     //ˢµǰʾ
     with MainForm do begin
          //
          DBGrid.Columns.Clear;
          for I:=0 to High(grGrid_Member) do begin

               with DBGrid.Columns.Add do begin
                    FieldName  := 'Item'+IntToStr(grGrid_Member[I]);
                    Width           := grFields_Member[grGrid_Member[I]].ViewWidth;
                    Title.Caption   := grFields_Member[grGrid_Member[I]].Caption;
                    PickList        := grFields_Member[grGrid_Member[I]].SelList;
               end;
          end;

          //õĲ˵
          TBXSubmenuItem_Sort.Clear;
          for I:=0 to High(grGrid_Member) do begin
               oSortMenu := TTBXItem.Create(self);
               oSortMenu.Caption   := grFields_Member[grGrid_Member[I]].Caption;
               oSortMenu.Tag       := grGrid_Member[I];
               oSortMenu.OnClick   := MenuItem_SortFieldClick;
               //oSortMenu.RadioItem := True;
               oSortMenu.AutoCheck := True;
               oSortMenu.GroupIndex     := 1;
               TBXSubmenuItem_Sort.Add(oSortMenu);
          end;

          //Ҽ˵
          PopMenu_Sort.Clear;
          for I:=0 to High(grGrid_Member) do begin
               oSortM := TMenuItem.Create(self);
               oSortM.Caption   := grFields_Member[grGrid_Member[I]].Caption;
               oSortM.Tag       := grGrid_Member[I];
               oSortM.OnClick   := MenuItem_SortFieldClick;
               oSortM.RadioItem := True;
               //oSortMenu.AutoCheck := True;
               //oSortMenu.GroupIndex     := 1;
               PopMenu_Sort.Add(oSortM);
          end;
     end;

     Close;

end;

procedure TForm_ColEdit.Button_SelectClick(Sender: TObject);
var
     sTmp : String;
begin
     if ListBox_All.ItemIndex>=0 then begin
          sTmp := ListBox_All.Items[ListBox_All.ItemIndex];
          if ListBox_Grid.Items.IndexOf(sTmp)=-1 then begin
               ListBox_Grid.Items.Add(sTmp);
               ListBox_Grid.Update;
               ListBox_All.Items.Delete(ListBox_All.ItemIndex);
          end;
     end;
end;

procedure TForm_ColEdit.Button_RemoveClick(Sender: TObject);
var
     sTmp : String;
begin
     if ListBox_Grid.ItemIndex>=0 then begin
          sTmp := ListBox_Grid.Items[ListBox_Grid.ItemIndex];
          if ListBox_All.Items.IndexOf(sTmp)=-1 then begin
               ListBox_All.Items.Add(sTmp);
               ListBox_All.Update;
               //
               ListBox_Grid.Items.Delete(ListBox_Grid.ItemIndex);
          end;
     end;
end;

procedure TForm_ColEdit.Button_MoveUpClick(Sender: TObject);
begin
     if ListBox_Grid.ItemIndex>0 then begin
          ListBox_Grid.Items.Exchange(ListBox_Grid.ItemIndex,ListBox_Grid.ItemIndex-1);
     end;
end;

procedure TForm_ColEdit.Button_MoveDownClick(Sender: TObject);
begin
     if ListBox_Grid.ItemIndex<ListBox_Grid.Count-1 then begin
          ListBox_Grid.Items.Exchange(ListBox_Grid.ItemIndex,ListBox_Grid.ItemIndex+1);
     end;

end;

end.
