unit FullView;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GR32_Image, ExtCtrls, Menus,Math, XPMenu;

type
  TForm_FullView = class(TForm)
    ImageView_Full: TImage32;
    Timer_FullView: TTimer;
    PopupMenu_FullView: TPopupMenu;
    PopMenu_Prev: TMenuItem;
    PopMenu_Next: TMenuItem;
    PopMenu_SlideShow: TMenuItem;
    N4: TMenuItem;
    PopMenu_ZoomIn: TMenuItem;
    PopMenu_ZoomOut: TMenuItem;
    PopMenu_ActualSize: TMenuItem;
    PopMenu_BestFit: TMenuItem;
    N11: TMenuItem;
    PopMenu_Print: TMenuItem;
    PopMenu_Edit: TMenuItem;
    N14: TMenuItem;
    PopMenu_Opetions: TMenuItem;
    PopMenu_WallPaper: TMenuItem;
    N17: TMenuItem;
    PopMenu_Help: TMenuItem;
    PopMenu_Exit: TMenuItem;
    PopMenu_Custom: TMenuItem;
    XPMenu: TXPMenu;
    N1: TMenuItem;
    procedure Timer_FullViewTimer(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ImageView_FullDblClick(Sender: TObject);
    procedure PopMenu_ZoomInClick(Sender: TObject);
    procedure PopMenu_ZoomOutClick(Sender: TObject);
    procedure PopMenu_FullViewClick(Sender: TObject);
    procedure PopMenu_ExitClick(Sender: TObject);
    procedure PopMenu_ActualSizeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_FullView: TForm_FullView;

implementation

uses Main;

{$R *.dfm}

procedure TForm_FullView.Timer_FullViewTimer(Sender: TObject);
begin
     ImageView_Full.Bitmap    := MainForm.ImageView.Bitmap;
end;

procedure TForm_FullView.FormDeactivate(Sender: TObject);
begin
     Timer_FullView.Enabled   := False;
end;

procedure TForm_FullView.FormActivate(Sender: TObject);
begin
     Timer_FullView.Enabled   := True;
     ImageView_Full.Bitmap    := MainForm.ImageView.Bitmap;
end;

procedure TForm_FullView.FormKeyPress(Sender: TObject; var Key: Char);
begin
//     showMessage(IntToStr(ord(Key)));
     //ESC˳
     if ord(Key) = 27 then Close;
     //ոһ
     if ord(Key) = 32 then PopMenu_Next.OnClick(Self);

     //Backspaceһ
     if ord(Key) = 8 then PopMenu_Prev.OnClick(Self);

     //+ Ŵ
     if (ord(Key) = 61)or(ord(Key) = 43) then PopMenu_ZoomIn.OnClick(Self);

     //- С
     if (ord(Key) = 45) then PopMenu_ZoomOut.OnClick(Self);

     //> 
     if (ord(Key) = 46) then PopMenu_SlideShow.OnClick(Self);

     /// ʵʴС
     if (ord(Key) = 47) then PopMenu_ActualSize.OnClick(Self);

end;

procedure TForm_FullView.ImageView_FullDblClick(Sender: TObject);
begin
     //ȥȫʾ־
     MainForm.MenuItem_FullView.Checked := False;
     //رյǰ
     Close;
end;

procedure TForm_FullView.PopMenu_ZoomInClick(Sender: TObject);
begin
     if ImageView_Full.Scale<100 then begin
          ImageView_Full.Scale     := ImageView_Full.Scale *1.2;
          PopMenu_Custom.Checked   := True;
     end;
end;

procedure TForm_FullView.PopMenu_ZoomOutClick(Sender: TObject);
var
     MinI : Integer;
begin
     MinI := Min(ImageView_Full.Bitmap.Width,ImageView_Full.Bitmap.Height);
     if MinI*ImageView_Full.Scale>10 then begin
          ImageView_Full.Scale     := ImageView_Full.Scale /1.2;
          PopMenu_Custom.Checked   := True;
     end;
end;

procedure TForm_FullView.PopMenu_FullViewClick(Sender: TObject);
begin
     MainForm.MenuItem_FullView.OnClick(self);
end;

procedure TForm_FullView.PopMenu_ExitClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_FullView.PopMenu_ActualSizeClick(Sender: TObject);
begin
     ImageView_Full.Scale     := 1;
end;

end.
