unit Options;

interface

uses
     SysConsts,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, ImgList, RzTabs, RzEdit, RzPanel,
  RzSplit, RXDBCtrl, DBCtrls, Grids, DBGrids, Buttons, ToolWin, Mask,
  ColorSelector;

type
  TForm_Options = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Button_OK: TButton;
    Button_Cancel: TButton;
    Panel_Demo: TPanel;
    Panel4: TPanel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    ColorSelector_Search: TColorSelector;
    ColorSelector_Group: TColorSelector;
    ColorSelector_Grid: TColorSelector;
    ColorSelector_Font: TColorSelector;
    Panel_Left: TPanel;
    Splitter_Bottom: TSplitter;
    PageControl_Group: TPageControl;
    TabSheet8: TTabSheet;
    TreeView: TTreeView;
    PageControl_Detail: TPageControl;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TabSheet6: TTabSheet;
    DBGrid_Resume: TDBGrid;
    TabSheet7: TTabSheet;
    DBGrid_Family: TDBGrid;
    TabSheet9: TTabSheet;
    DBMemo1: TDBMemo;
    TabSheet10: TTabSheet;
    Panel_Brief: TPanel;
    RichEdit_Brief: TRzRichEdit;
    Panel_Split: TPanel;
    Panel_Client: TPanel;
    Panel_R_B: TPanel;
    Panel_R_B_C: TPanel;
    ListView: TListView;
    Panel_Search: TPanel;
    Button_FastSearch: TSpeedButton;
    Edit_FastSearch: TEdit;
    ComboBox_SearchItem: TComboBox;
    Button_Default: TButton;
    procedure FormShow(Sender: TObject);
    procedure ColorSelector_SearchChangeColor(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_OKClick(Sender: TObject);
    procedure Button_DefaultClick(Sender: TObject);
    procedure ColorSelector_GridClick(Sender: TObject);
  private
     piGridColor1   : TColor;
     piGridColor2   : TColor;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form_Options: TForm_Options;

implementation

{$R *.dfm}
uses Main,DataHouse;

procedure TForm_Options.FormShow(Sender: TObject);
begin
     //ʾ
     TreeView.Items[0].Expand(True);
     ListView.Items.Clear;
     with ListView.Items.Add do begin
          Caption   := 'Զ';
          SubItems.Add('');
          SubItems.Add('45300355');
          SubItems.Add('FengLinYuShu@163.com');
     end;
     with ListView.Items.Add do begin
          Caption   := '';
          SubItems.Add('½');
          SubItems.Add('');
          SubItems.Add('LucyBaby626@177.com');
     end;
     with ListView.Items.Add do begin
          Caption   := '';
          SubItems.Add('Ĵ');
          SubItems.Add('234567890');
          SubItems.Add('lyl_1234567@747.com');
     end;
     with ListView.Items.Add do begin
          Caption   := '';
          SubItems.Add('');
          SubItems.Add('87654321');
          SubItems.Add('BiShuXiFeng@163.com');
     end;
     //------------------------------ɫ-----------------------------------------------------//
     //Form_Options.Panel_Search.Color    := MainForm.Panel_Search.Color;
     Form_Options.TreeView.Color        := MainForm.TreeView.Color;
     Form_Options.TreeView.Font.Color   := MainForm.TreeView.Font.Color;
     Form_Options.ListView.Color        := MainForm.DBGrid.Color;
     Form_Options.Panel_Brief.Color     := MainForm.Panel_Brief.Color;
     Form_Options.TreeView.Font.Color   := MainForm.TreeView.Font.Color;
     Form_Options.RichEdit_Brief.Font.Color   := MainForm.RichEdit_Brief.Font.Color;
     //
     //ColorSelector_Search.Color   := MainForm.Panel_Search.Color;
     ColorSelector_Group.Color    := MainForm.TreeView.Color;
     ColorSelector_Font.Color      := MainForm.TreeView.Font.Color;
     ColorSelector_Grid.Color     := giGridColor1;
     //ColorSelector_Grid2.Color    := giGridColor2;
     piGridColor1   := giGridColor1;
     piGridColor2   := giGridColor2;
end;

procedure TForm_Options.ColorSelector_SearchChangeColor(Sender: TObject);
begin
     //
     Panel_Search.Color  := ColorSelector_Search.Color    ;
     TreeView.Color      := ColorSelector_Group.Color     ;
     TreeView.Font.Color := ColorSelector_Font.Color      ;
     ListView.Color      := ColorSelector_Grid.Color      ;
     //
     Panel_Brief.Color   := TreeView.Color;
     RichEdit_Brief.Font.Color     := TreeView.Font.Color;

end;

procedure TForm_Options.Button_CancelClick(Sender: TObject);
begin
     Close;
end;

procedure TForm_Options.Button_OKClick(Sender: TObject);
begin
     //------------------------------ɫ---------------------------------------------------------//
     //浽ݿ
     MainForm.SetSystemByID(IntToStr(ColorSelector_Search.Color),siSearchColor);
     MainForm.SetSystemByID(IntToStr(ColorSelector_Group.Color),siGroupColor);
     MainForm.SetSystemByID(IntToStr(ColorSelector_Font.Color),siGroupFontColor);
     MainForm.SetSystemByID(IntToStr(ColorSelector_Grid.Color),siGridColor1);
     //MainForm.SetSystemByID(IntToStr(ColorSelector_Grid2.Color),siGridColor2);

     //µǰɫ
     //MainForm.Panel_Search.Color    := Panel_Search.Color;
     MainForm.TreeView.Color        := TreeView.Color;
     MainForm.TreeView.Font.Color   := TreeView.Font.Color;
     giGridColor1   := ColorSelector_Grid.Color;
     //giGridColor2   := ColorSelector_Grid2.Color;
     //
     MainForm.RichEdit_Brief.Font.Color     := TreeView.Font.Color;
     MainForm.Panel_Brief.Color              := Panel_Brief.Color;
     //MainForm.RichEdit_Brief..ReadOnlyColor   := Panel_Brief.Color;
     MainForm.Panel_BriefBorder.Color   := MainForm.TreeView.Color;
     MainForm.RichEdit_Brief.Color      := MainForm.TreeView.Color;
     MainForm.DBGrid.Color              := giGridColor1;

     //
     Close;
end;

procedure TForm_Options.Button_DefaultClick(Sender: TObject);
begin
     //µǰɫ
     Form_Options.Panel_Search.Color    := clInfoBK;
     Form_Options.TreeView.Color        := $00FF953D;
     Form_Options.TreeView.Font.Color   := clBlack;
     Form_Options.ListView.Color        := clWhite;
     Form_Options.Panel_Brief.Color     := Form_Options.TreeView.Color;
     Form_Options.RichEdit_Brief.Font.Color  := Form_Options.TreeView.Font.Color;
     //
     piGridColor1   := clWhite;
     piGridColor2   := RGB(250,250,250);
     //
     ColorSelector_Search.Color   := Form_Options.Panel_Search.Color;
     ColorSelector_Group.Color    := Form_Options.TreeView.Color;
     ColorSelector_Font.Color     := Form_Options.TreeView.Font.Color;
     ColorSelector_Grid.Color     := Form_Options.ListView.Color;
     //ColorSelector_Grid2.Color     := piGridColor2;
     //
     ListView.Repaint;

end;

procedure TForm_Options.ColorSelector_GridClick(Sender: TObject);
begin
     piGridColor1   := ColorSelector_Grid.Color;
end;

end.
